#ifndef __SUPPORT_H__
#define __SUPPORT_H__

#ifdef MALLOC_DEBUG

#include "dmalloc.h"

#define MyFree(__x)			dmalloc_free((__x), __FILE__, __LINE__)
#define MyMalloc(__x)		dmalloc_malloc((__x), __FILE__, __LINE__)
#define MyRealloc(__x, __y)	dmalloc_realloc((__x), (__y), __FILE__, __LINE__)
#define MyStrdup(__x)		dmalloc_strdup((__x), __FILE__, __LINE__)

#else

#define MyFree(__x)			support_free((__x))
#define MyMalloc(__x)		support_malloc((__x))
#define MyRealloc(__x, __y)	support_realloc((__x), (__y))
#define MyStrdup(__x)		support_strdup((__x))

#endif

#if 1
/* leave out type casts for now */
#define BCOPY(__x, __y, __z) support_bcopy((__x), (__y), (__z))
#define BCMP(__x, __y, __z)	support_bcmp((__x), (__y), (__z))
#define BZERO(__x, __y)		support_bzero((__x), (__y))
#else
#define BCOPY(__x, __y, __z) support_bcopy((void *)(__x), (void *)(__y), (__z))
#define BCMP(__x, __y, __z)	support_bcmp((void *)(__x), (void *)(__y), (__z))
#define BZERO(__x, __y)		support_bzero((void *)(__x), (__y))
#endif

int ircd_getpagesize(void);
void support_free(void *ptr);
void support_free_dbg(void *ptr, char *filename, int lineno);
void *support_malloc(size_t len);
void *support_realloc(void *ptr, size_t len);
char *support_strdup(char *string);
void support_bcopy(const void *, void *, size_t);
int support_bcmp(const void *s1, const void *s2, size_t n);
void support_bzero(void *s, size_t n);
char *support_get_token(char **src, char *token_sep);
char *support_strncpy(char *dest, char *src, int len);
char *support_stristr(char *str1, char *str2);
char *support_ctime(int thetime);
char *support_strerror(int errnum);

#endif
